package and09.multiweatherapp

import and09.multiweatherapp.weatherapi.OpenWeatherMapAPI
import and09.multiweatherapp.weatherapi.SpringWeatherAPI
import and09.multiweatherapp.weatherapi.WeatherStackAPI
import org.json.JSONException
import org.junit.Test

import org.junit.Assert.*
import org.junit.runner.RunWith
import org.robolectric.RobolectricTestRunner
import java.io.IOException

/**
 * Example local unit test, which will execute on the development machine (host).
 *
 * See [testing documentation](http://d.android.com/tools/testing).
 */
@RunWith(RobolectricTestRunner::class)

class ExampleUnitTest {
    @Test
    fun addition_isCorrect() {
        assertEquals(4, 2 + 2)
    }

    @Test
    fun openWeatherMap_getResponseFromName() {
        val api = OpenWeatherMapAPI.fromLocationName("Witzenhausen")
        println("Temp: ${api.temperature}")
        println("Description: ${api.description}")
        println("Icon: ${api.iconUrl}")
        println("Location: ${api.location}")
    }

    @Test
    fun owm_getResponseFromLatLon() {
        val api = OpenWeatherMapAPI.fromLatLon(37.77, -122.42)
        println("Temp: ${api.temperature}")
        println("Description: ${api.description}")
        println("Icon: ${api.iconUrl}")
        println("Location: ${api.location}")
    }
    @Test
    @Throws(IOException::class, JSONException::class)
    fun weatherStack_getResponseFromName() {
        val api = WeatherStackAPI.fromLocationName("Celle")
    }
    @Test
    @Throws(IOException::class, JSONException::class)
    fun weatherStack_getResponseFromLatLon() {
        val api = WeatherStackAPI.fromLatLon(37.77, -122.42)
    }

    @Test
    @Throws(IOException::class, JSONException::class)
    fun springWeatherAPI_getResponseFromName() {
        val api = SpringWeatherAPI.fromLocationName("San Francisco")
        println("Temp: ${api.temperature}")
        println("Description: ${api.description}")
        println("Icon: ${api.iconUrl}")
        println("Location: ${api.location}")
    }
    @Test
    @Throws(IOException::class, JSONException::class)
    fun springWeatherAPI_getResponseFromLatLon() {
        val api = SpringWeatherAPI.fromLatLon(37.77, -122.42)
        println("Temp: ${api.temperature}")
        println("Description: ${api.description}")
        println("Icon: ${api.iconUrl}")
        println("Location: ${api.location}")
    }
}